;- Beispiel fr PADDSB
;- Packed Signed Bytes Add with Saturation
;- MMX - wie PADDB, aber die Bytes werden als vorzeichenbehaftet interpretiert und bei ber-
;-  oder Unterlauf wird saturiert (max = 127 (7fh) bzw. min = -128 (80h))
;- Dateiname 103.pb
;- "Helle" Klaus Helbing, 27.12.2006, PB v4.02
;- Operand2 kann ein Register oder eine Variable sein, Operand1 muss ein Register sein 

!movq mm0,[X]
!paddsb mm0,[Y]
!movq [R],mm0
!emms

MessageRequester("PADDSB", HexQ(PeekQ(?R)))      ;Hex nur wegen deutlicherer Darstellung

;Beispiel fr Saturierung, siehe Byte 0, dort gehts nur bis 7fh
!movq mm0,[X]
!paddsb mm0,[Z]
!movq [R],mm0
!emms

MessageRequester("PADDSB mit Saturierung", HexQ(PeekQ(?R)))

;Ab SSE2 knnen auch XMM-Register verwendet werden
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!
End

!section '.data' Data readable writeable
!X DQ 101020203030404h
!Y DQ 101020203030404h
!Z DQ 10102020303047eh
R:
!R DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 24
; Folding = -
; EnableAsm
; DisableDebugger