;- Beispiel fr PFRCP
;- Single-FP Reciprocal Approximation
;- 3DNow1 - berechnet den Kehrwert der Fliesskommazahl einfacher Genauigkeit des unteren Double-Words
;-  von Operand2 und speichert das Ergebnis in den beiden Double-Words von Operand1
;- Dateiname 1104.pb
;- "Helle" Klaus Helbing, 01.01.2007, PB v4.02
;- Operand2 kann ein MMX-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein
;- PFRCP allein liefert nur 14 Bits Genauigkeit. 24-Bit-Genauigkeit erhlt man in Verbindung mit
;-  PFCRPIT1 und PFRCPIT2
;- Hat Operand2 den Wert Null, wird der grsstmgliche Wert mit dem Vorzeichen von Operand2
;-  zurckgeliefert (man beachte: 0.0 und -0.0 sind mglich!)
;- Ist das Ergebnis kleiner als 2^126, so wird Null mit dem Vorzeichen von Operand2 zurckgeliefert
;- Ist sehr schnell, weil zur Berechnung eine in der CPU implementierte Tabelle benutzt wird!

Global A.f = 1234.5

!femms                       ;sollte immer einen 3DNow!-Block umklammern!
!movd mm1,[v_A]              ;belegt nur das untere Double-Word! 
!pfrcp mm0,mm1               ;in beiden Double-Words von MM0 steht jetzt der Kehrwert von A 
!movq [R],mm0
!femms

MessageRequester("PFRCP", StrF(PeekF(?R + 4),10))     ;4 Byte 1.Float-Zahl
MessageRequester("PFRCP", StrF(PeekF(?R),10))         ;4 Byte 2.Float-Zahl

End

!section '.data' Data readable writeable
R:
!R DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableAsm
; DisableDebugger