;- Beispiel fr PFRCPIT1
;- Packed Single-FP Reciprocal First Iteration Step
;- 3DNow! - berechnet die erste Iteration des Newton-Raphson-Verfahrens einer vorher mit PFRCP
;-  berechneten Zahl
;- Dateiname 1105.pb
;- "Helle" Klaus Helbing, 01.01.2007, PB v4.02
;- Operand2 kann ein MMX-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein
;- PFRCPIT1 allein anzuwenden macht wohl wenig Sinn, deshalb hier das Zusammenspiel mit PFRCPIT2
;- Das Beispiel berechnet Q = A / B mit 24 Bit Genauigkeit nach folgendem Schema:
;- X0 = PFRCP(B)             ;Kehrwert von B
;- X1 = PFRCPIT1(B,X0)       ;1.Iteration
;- X2 = PFRCPIT2(X1,X0)      ;2.Iteration
;-  Q = PFMUL(A,X2)          ;Multiplikation mit A

Global A.f = 1234.5
Global B.f = 678.9
Global Q.f

!femms                       ;sollte immer einen 3DNow!-Block umklammern!
!movd mm0,[v_A]              ;belegt nur das untere Double-Word! 
!movd mm1,[v_B]
!pfrcp mm2,mm1               ;muss vorher ausgefhrt werden
!pfrcpit1 mm1,mm2            ;muss vorher ausgefhrt werden
!pfrcpit2 mm1,mm2
!pfmul mm0,mm1
!movd [v_Q],mm0
!femms

MessageRequester("PFRCPIT1", StrF(Q,10))

End
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableAsm
; DisableDebugger