;- Beispiel fr PSUBSW
;- Packed Signed Words Subtract with Saturation
;- MMX - wie PSUBW, aber die Words werden als vorzeichenbehaftet interpretiert und bei
;-  ber- oder Unterlauf wird saturiert (max = 32767 (7fffh) bzw. min = -32768 (8000h))
;- Dateiname 114.pb
;- "Helle" Klaus Helbing, 27.12.2006, PB v4.02
;- Operand2 kann ein Register oder eine Variable sein, Operand1 muss ein Register sein 

!movq mm0,[X]
!psubsw mm0,[Y]
!movq [R],mm0
!emms

MessageRequester("PSUBSW", HexQ(PeekQ(?R)))      ;Hex nur wegen deutlicherer Darstellung

;Beispiel fr Saturierung, siehe Word 0, (Unterlauf = 8000h)
!movq mm0,[X]
!psubsw mm0,[Z]
!movq [R],mm0
!emms

MessageRequester("PSUBSW mit Saturierung", HexQ(PeekQ(?R)))

;Ab SSE2 knnen auch XMM-Register verwendet werden
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!
End

!section '.data' Data readable writeable
!X DQ 50506060707f8f8h
!Y DQ 101020203030404h
!Z DQ 101020203037e7eh
R:
!R DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 24
; Folding = -
; EnableAsm
; DisableDebugger