;- Beispiel fr PF2ID
;- Convert Packed Single-FP to Packet 32-Bit-Integer
;- 3DNow! - konvertiert die beiden Fliesskommazahlen einfacher Genauigkeit des zweiten Operanden
;-  in zwei vorzeichenbehaftete 32-Bit-Integer-Zahlen in den ersten Operanden
;- Dateiname 1200.pb
;- "Helle" Klaus Helbing, 01.01.2007, PB v4.02
;- Operand2 kann ein MMX-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein
;- Ist der FP-Wert grsser oder gleich 2^31, wird 7fffffffh in das entsprechende Double-Word von 
;- Operand1 geschrieben
;- Ist der FP-Wert kleiner oder gleich -2^31, wird 80000000h in das entsprechende Double-Word von
;- Operand1 geschrieben

Global A.f = 1234.5
Global B.f = 678.9

!femms                       ;sollte immer einen 3DNow!-Block umklammern!
!movd mm0,[v_A]              ;belegt nur das untere Double-Word! 
!pswapd mm0,mm0              ;oberes Double-Word mit Wert belegen
!movd mm1,[v_B]
!pfadd mm0,mm1               ;unteres Double-Word mit Wert belegen
!pf2id mm1,mm0 
!movq [R],mm1
!femms

MessageRequester("PF2ID", Str(PeekL(?R + 4)))    ;4 Byte 1.Integer-Zahl
MessageRequester("PF2ID", Str(PeekL(?R)))        ;4 Byte 2.Integer-Zahl

End

!section '.data' Data readable writeable
R:
!R DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableAsm
; DisableDebugger