;- Beispiel fr PSLLQ
;- (Packed) Quad-Words Shift Left Logical
;- MMX - shiftet die Bits innerhalb des/der Quad-Words des ersten Operanden um die im zweiten
;-  Operanden angegebene Anzahl nach links. Von rechts wird mit Nullen aufgefllt
;- Dateiname 202.pb
;- "Helle" Klaus Helbing, 13.01.2007, PB v4.02
;- Operand2 kann ein Register, eine Variable oder eine 8-Bit-Konstante sein, Operand1 muss ein Register sein 
;- Ist Operand2 grsser 63, so wird das Ergebnis Null

!movq mm0,[X]
!psllq mm0,[Y]
!movq [R],mm0
!emms

MessageRequester("PSLLQ   Shiftet X um eine Bitstelle (Y) nach links", HexQ(PeekQ(?R)))  ;Hex nur wegen deutlicherer Darstellung

;Beispiel mit Konstante
!movq mm0,[X]
!psllq mm0,40                ;entspricht Multiplikation mit 1099511627776 (10000000000h)       
!movq [R],mm0 
!emms

MessageRequester("PSLLQ mit Konstante", HexQ(PeekQ(?R)))

End      ;<=== Kann entfernt werden wenn SSE2 zur Verfgung steht

;Ab SSE2 knnen auch XMM-Register verwendet werden, hier ein Beispiel fr ein Double-Quad-Word 
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!
!movdqu xmm0,dqword[Z]       ;ldt 128 Bit
!psllq xmm0,1                ;entspricht Multiplikation mit 2       
!movdqu dqword[R],xmm0 

MessageRequester("PSLLQ mit XMM-Register, 128-bittig", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                                                      oberes Quad-Word           unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ       101020203030404h
!Y DQ                     1h
!Z DQ       101020203030404h           ;unteres Quad-Word von Z (in Operand1)
!times 1 DQ 505060607070808h           ;oberes Quad-Word von Z (in Operand1)
R:
!R DQ ?
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 5
; FirstLine = 2
; Folding = -
; EnableAsm
; DisableDebugger