;- Beispiel fr PFNACC
;- Packed Single-FP Negative Accumulate
;- Extended 3DNow! - subtrahiert die obere von der unteren FP-Zahl von Operand1 und speichert das
;-  Ergebnis im unteren Double-Word von Operand1. Die gleiche Rechnung wird mit Operand2 vorgenommen,
;-  nur wird das Ergebnis im oberen Double-Word von Operand1 gespeichert  
;- Dateiname 2102.pb
;- "Helle" Klaus Helbing, 12.01.2007, PB v4.02
;- Gehrt zu den 5 DSP-Befehlen (Digital Signal Processing)
;- Operand2 kann ein MMX-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein

Global A.f = 1234.5
Global B.f = 678.9

!femms                       ;sollte immer einen 3DNow!-Block umklammern!
!movd mm0,[v_A]
!psllq mm0,32
!movd mm1,[v_B]
!paddd mm0,mm1               ;in MM0 stehen jetzt A und B, in MM1 nur B
 
!pfnacc mm0,mm1

!movq [R],mm0
!femms

MessageRequester("PFNACC  Subtrahiert 0 von B", StrF(PeekF(?R + 4))) ;oberes Double-Word von MM0 (B-0)
MessageRequester("PFNACC  Subtrahiert A von B", StrF(PeekF(?R)))     ;unteres Double-Word von MM0 (B-A)

End

!section '.data' Data readable writeable
R:
!R DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 25
; Folding = -
; EnableAsm
; DisableDebugger