;- Beispiel fr PFPNACC
;- Packed Single-FP Mixed Positive-Negative Accumulate
;- Extended 3DNow! - subtrahiert die obere von der unteren FP-Zahl von Operand1 und speichert das
;-  Ergebnis im unteren Double-Word von Operand1. Von Operand2 werden die 2 FP-Zahlen addiert und
;-  das Ergebnis wird im oberen Double-Word von Operand1 gespeichert  
;- Dateiname 2103.pb
;- "Helle" Klaus Helbing, 12.01.2007, PB v4.02
;- Gehrt zu den 5 DSP-Befehlen (Digital Signal Processing)
;- Operand2 kann ein MMX-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein

Global A.f = 1234.5
Global B.f = 678.9

!femms                       ;sollte immer einen 3DNow!-Block umklammern!
!movd mm0,[v_A]
!psllq mm0,32
!movd mm1,[v_B]
!paddd mm0,mm1               ;in MM0 stehen jetzt A und B, in MM1 nur B

!pfpnacc mm1,mm0

!movq [R],mm1
!femms

MessageRequester("PFPNACC  Addiert A und B", StrF(PeekF(?R + 4))) ;oberes Double-Word von MM0 (A+B)
MessageRequester("PFPNACC  Subtrahiert 0 von B", StrF(PeekF(?R))) ;unteres Double-Word von MM0 (B-0)

End

!section '.data' Data readable writeable
R:
!R DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableAsm
; DisableDebugger