;- Beispiel fr PF2IW
;- Convert Packed Single-FP to Packet 16-Bit-Integer with Sign Extension
;- Extended 3DNow! - konvertiert die beiden Fliesskommazahlen einfacher Genauigkeit des zweiten
;-  Operanden in zwei vorzeichenbehaftete 16-Bit-Integer-Zahlen in den ersten Operanden. Nachkomma-
;-  Stellen werden abgeschnitten. Unter Beibehaltung des Vorzeichens werden die Ergebnisse dann auf
;-  32-Bit-Integer erweitert 
;- Dateiname 2200.pb
;- "Helle" Klaus Helbing, 12.01.2007, PB v4.02
;- Gehrt zu den 5 DSP-Befehlen (Digital Signal Processing)
;- Operand2 kann ein MMX-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein
;- Bei ber- oder Unterlauf wird saturiert. Bei Unterlauf wird ffff8000h, bei berlauf wird 00007fffh
;-  in das entsprechende Double-Word von Operand1 geschrieben

Global A.f = 1234.5
Global B.f = 678.9

!femms                       ;sollte immer einen 3DNow!-Block umklammern!
!movd mm0,[v_A]              ;belegt nur das untere Double-Word! 
!pswapd mm0,mm0              ;oberes Double-Word mit Wert belegen
!movd mm1,[v_B]
!pfadd mm0,mm1               ;unteres Double-Word mit Wert belegen
!pf2iw mm1,mm0 
!movq [R],mm1
!femms

MessageRequester("PF2IW", Str(PeekL(?R + 4)))    ;oberes Double-Word von MM1
MessageRequester("PF2IW", Str(PeekL(?R)))        ;unteres Double-Word von MM1

End

!section '.data' Data readable writeable
R:
!R DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 7
; Folding = -
; EnableAsm
; DisableDebugger