;- Beispiel fr MOVAPS
;- Move Aligned Packed Single-Precision Floating-Point Values 
;- SSE - kopiert den zweiten Operanden in den ersten
;- Bei Verwendung einer Variable muss diese an einer 16-Byte-Adresse ausgerichtet sein
;- Dateiname 3002.pb
;- "Helle" Klaus Helbing, 21.06.2007, PB v4.02
;- Die Operanden knnen 128-Bit-Register oder 128-Bit-Variablen sein. Ein Operand muss ein Register sein
;- Wenn kein 16-Byte-Alignment vorhanden ist muss MOVUPS verwendet werden (ist aber langsamer)

!movaps xmm0,dqword[X]       ;ldt X (128 Bit), also alle 4 Single-Floats
!movaps dqword[R],xmm0
 
MessageRequester("MOVAPS", StrF(PeekF(?R)) + #LFCR$ + StrF(PeekF(?R+4)) + #LFCR$ + StrF(PeekF(?R+8)) + #LFCR$ + StrF(PeekF(?R+12)))

End

!section '.data' Data readable writeable
;!A DB ?                     ;hiermit kann man Unalignment testen!
;16-Byte-Alignment ist hier am Anfang der Data-Section garantiert
!X DD 123456.7890            ;unterstes (1.) Double-Word von X (Operand2)
!  DD 098765.4321            ;2.Double-Word von X (Operand2) 
!  DD 345678.9012            ;3.Double-Word von X (Operand2)
!  DD 765432.1987            ;oberstes (4.)Double-Word von X (Operand2)
R:
!R DQ ?                      ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!  DQ ?                      ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 25
; Folding = -
; EnableAsm
; DisableDebugger