;- Beispiel fr MOVNTPS
;- Move Packed Single-Precision Floating-Point Values Using Non-Temporal Hint 
;- SSE - kopiert die vier Fliesskommazahlen einfacher Genauigkeit des zweiten Operanden
;-  (XMM-Register) in den ersten Operanden (128-Bit-Variable) ohne die Daten zu cachen
;- Dateiname 3008.pb
;- "Helle" Klaus Helbing, 21.06.2007, PB v4.02
;- Operand2 muss ein XMM-Register und Operand1 muss eine 128-Bit-Variable sein
;- Bei den Cache-Umgehungsbefehlen sollte vorher immer SFENCE bzw. MFENCE ausgefhrt werden um sicher 
;-  zu sein, das sich der Speicher whrend der Ausfhrung nicht ndert
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!movups xmm0,dqword[X]       ;ldt X (128 Bit), also alle 4 Single-Floats
!sfence                      ;evtl. noch anstehende Speicher-Schreib-Vorgnge abarbeiten
!movntps dqword[R],xmm0
 
MessageRequester("MOVNTPS", StrF(PeekF(?R)) + #LFCR$ + StrF(PeekF(?R+4)) + #LFCR$ + StrF(PeekF(?R+8)) + #LFCR$ + StrF(PeekF(?R+12)))

End

!section '.data' Data readable writeable
!X DD 123456.7890            ;unterstes (1.) Double-Word von X (Operand2)
!  DD 098765.4321            ;2.Double-Word von X (Operand2) 
!  DD 345678.9012            ;3.Double-Word von X (Operand2)
!  DD 765432.1987            ;oberstes (4.)Double-Word von X (Operand2)
R:
!R DQ ?                      ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!  DQ ?                      ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 26
; Folding = -
; EnableAsm
; DisableDebugger