;- Beispiel fr MOVSS
;- Move Scalar Single-Precision Floating-Point Value 
;- SSE - kopiert eine (die unterste) Fliesskommazahl einfacher Genauigkeit vom zweiten Operanden
;-  in den ersten Operanden
;- Dateiname 3010.pb
;- "Helle" Klaus Helbing, 21.06.2007, PB v4.02
;- Die Operanden knnen 128-Bit-Register oder 32-Bit-Variablen sein. Ein Operand muss ein Register sein
;- Wird von Register zu Register kopiert, wird nur das untere Double-Word kopiert; die 3 oberen bleiben
;- unverndert. Wird von Variable in Register kopiert, werden die restlichen 3 oberen Double-Words des 
;- Registers auf Null gesetzt 

Global R.f 

!movups xmm0,dqword[X]       ;ldt X (128 Bit), also alle 4 Single-Floats
!movss [v_R],xmm0
 
MessageRequester("MOVSS  XMM-Register in Variable", StrF(R))

;- Beispiel mit einer Single-Precision Float-Variable, XMM0 hat noch den Wert von X  
Global A.f = 1234.5

!movss xmm0,[v_A]
!movups dqword[R1],xmm0

MessageRequester("MOVSS  Variable in XMM-Register", StrF(PeekF(?R1)))     ;unterstes Double-Word
MessageRequester("MOVSS  Variable in XMM-Register", StrF(PeekF(?R1 + 4))) ;die anderen Double-Words
MessageRequester("MOVSS  Variable in XMM-Register", StrF(PeekF(?R1 + 8))) ;  werden auf Null gesetzt
MessageRequester("MOVSS  Variable in XMM-Register", StrF(PeekF(?R1 + 12)))

End

!section '.data' Data readable writeable
!X DD 123456.7890            ;unterstes (1.) Double-Word von X (Operand2)
!  DD 098765.4321            ;2.Double-Word von X (Operand2) 
!  DD 345678.9012            ;3.Double-Word von X (Operand2)
!  DD 765432.1987            ;oberstes (4.)Double-Word von X (Operand2)
R1:
!R1 DQ ?                     ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!   DQ ?                     ;noch ein weiteres Quad-Word reservieren

; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 16
; Folding = -
; EnableAsm
; DisableDebugger