;- Beispiel fr MOVUPS
;- Move Unaligned Packed Single-Precision Floating-Point Values 
;- SSE - kopiert den zweiten Operanden in den ersten. Bei Verwendung einer Variable muss diese
;-  nicht an einer 16-Byte-Adresse ausgerichtet sein
;- Dateiname 3011.pb
;- "Helle" Klaus Helbing, 21.06.2007, PB v4.02
;- Die Operanden knnen 128-Bit-Register oder 128-Bit-Variablen sein. Ein Operand muss ein Register sein
;- Wenn ein 16-Byte-Alignment vorhanden ist kann MOVAPS verwendet werden (ist schneller)

!movups xmm0,dqword[X]       ;ldt X (128 Bit), also alle 4 Single-Floats
!movups dqword[R],xmm0
 
MessageRequester("MOVUPS", StrF(PeekF(?R)) + #LFCR$ + StrF(PeekF(?R+4)) + #LFCR$ + StrF(PeekF(?R+8)) + #LFCR$ + StrF(PeekF(?R+12)))
End

!section '.data' Data readable writeable
;16-Byte-Alignment ist hier am Anfang der Data-Section garantiert
!A DB ?                      ;Unalignment erzeugen
!X DD 123456.7890            ;unterstes (1.) Double-Word von X (Operand2)
!  DD 098765.4321            ;2.Double-Word von X (Operand2) 
!  DD 345678.9012            ;3.Double-Word von X (Operand2)
!  DD 765432.1987            ;oberstes (4.)Double-Word von X (Operand2)
R:
!R DQ ?                      ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!  DQ ?                      ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableAsm
; DisableDebugger