;- Beispiel fr CVTPS2PI
;- Convert Packed Single-FP to 32-Bit-Integer 
;- SSE - konvertiert die beiden Fliesskommazahlen einfacher Genauigkeit des zweiten Operanden
;-  in zwei vorzeichenbehaftete 32-Bit-Integer-Zahlen (mit Rundung) in den ersten Operanden
;- Dateiname 3101.pb
;- "Helle" Klaus Helbing, 27.12.2006, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein
;- Ist Operand2 ein XMM-Register, werden nur die beiden unteren Fliesskommazahlen konvertiert
;- Gerundet wird gemss Angabe im MXCSR-Register
;- Ist das Integer-Ergebnis grsser als die 32-Bit, wird der undefinierte Wert 80000000h zurckgegeben

Global A.f = 1234.5
Global B.f = 678.9

!movd mm1,[v_A]
!movd mm0,[v_B]
!punpckldq mm0,mm1           ;A und B stehen jetzt in MM0

!movq [X],mm0                ;um nicht den SSE2-Befehl movq2dq xmm0,mm0 (gefolgt von cvtps2pi mm0,xmm0)
!cvtps2pi mm0,[X]            ; benutzen zu mssen hier der Umweg ber Speicher-Variable
!movq [R],mm0
!emms                        ;da MMX-Register benutzt wurden

MessageRequester("CVTPS2PI", Str(PeekL(?R + 4))) ;4 Byte 1.Integer-Zahl
MessageRequester("CVTPS2PI", Str(PeekL(?R)))     ;4 Byte 2.Integer-Zahl

End

!section '.data' Data readable writeable
R:
!R DQ ?
!X DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 13
; Folding = -
; EnableAsm
; DisableDebugger