;- Beispiel fr CVTTPS2PI
;- Convert with Truncation Packed Single-FP to 32-Bit-Integer 
;- SSE - konvertiert die beiden Fliesskommazahlen einfacher Genauigkeit des 2.Operanden in zwei
;-  vorzeichenbehaftete 32-Bit-Integer-Zahlen (mit Abschneidung) in den 1.Operanden
;- Dateiname 3104.pb
;- "Helle" Klaus Helbing, 17.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 64-Bit-Variable sein, Operand1 muss ein MMX-Register sein
;- Ist Operand2 ein XMM-Register, werden nur die beiden unteren Fliesskommazahlen konvertiert
;- Es findet keine Rundung statt, sondern Nachkommastellen werden abgeschnitten
;- Ist das Integer-Ergebnis grsser als die 32-Bit, wird der undefinierte Wert 80000000h zurckgegeben  

Global A.f = 1234.5
Global B.f = 678.9

!movd mm1,[v_A]
!movd mm0,[v_B]
!punpckldq mm0,mm1           ;A und B stehen jetzt in MM0
!movq [X],mm0                ;hier als Beispiel 64-Bit-Variable

!cvttps2pi mm0,[X]
!movq [R],mm0
!emms                        ;da MMX-Register benutzt wurden

MessageRequester("CVTTPS2PI", Str(PeekL(?R + 4))) ;4 Byte 1.Integer-Zahl
MessageRequester("CVTTPS2PI", Str(PeekL(?R)))     ;4 Byte 2.Integer-Zahl

End

!section '.data' Data readable writeable
R:
!R DQ ?
!X DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 17
; Folding = -
; EnableAsm
; DisableDebugger