;- Beispiel fr PAVGB
;- Packed Average Byte
;- SSE - berechnet den Durchschnittswert der einzelnen vorzeichenlosen korrespondierenden Bytes
;-  und speichert die Ergebnisse im ersten Operanden
;- Dateiname 3206.pb
;- "Helle" Klaus Helbing, 13.01.2007, PB v4.02
;- Operand2 kann ein MMX (XMM)-Register oder eine 64 (128)-BitVariable sein, Operand1 muss ein 
;- MMX (XMM)-Register sein
;- Es wird byte-weise der Durchschnittswert ermittelt. Man beachte, dass "aufgerundet" wird, da 
;- die Byte-Summe vor der Division durch 2 um 1 inkrementiert wird 
;- Die Bytes werden als vorzeichenlos interpretiert
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- Beispiel mit MMX-Register
!movq mm0,[X]
!pavgb mm0,[Y]
!movq [R],mm0
!emms                        ;da MMX-Register benutzt wurden

MessageRequester("PAVGB   MMX-Beispiel, z.B. 06h ist ((08h + 03h) + 1h) / 2", HexQ(PeekQ(?R)))       ;Hex nur wegen deutlicherer Darstellung

;- Beispiel mit XMM-Register
!xorps xmm0,xmm0             ;XMM0 = Operand1 zur Vereinfachung auf Null setzen
!pavgb xmm0,dqword[X]        ;also X (wird unteres Quad-Word) und Y (wird oberes Quad-Word) laden
!movups dqword[R],xmm0

MessageRequester("PAVGB   XMM-Beispiel, z.B. 02h ist ((0h + 03h) + 1h) / 2", RSet(HexQ(PeekQ(?R + 8)),16,"0") + RSet(HexQ(PeekQ(?R)),16,"0"))
;                                                      Op.1 Op.2                  oberes Quad-Word                   unteres Quad-Word

End 

!section '.data' Data readable writeable
!X DQ 102030405060708h
!Y DQ 303030303030303h
R:
!R DQ ?
!times 1 DQ ?                          ;2,Quad-Word fr XMM-Beispiel
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 22
; Folding = -
; EnableAsm
; DisableDebugger