;- Beispiel fr PAVGW
;- Packed Average Word
;- SSE - berechnet den Durchschnittswert der einzelnen vorzeichenlosen korrespondierenden Words
;-  und speichert die Ergebnisse im ersten Operanden
;- Dateiname 3207.pb
;- "Helle" Klaus Helbing, 13.01.2007, PB v4.02
;- Operand2 kann ein MMX (XMM)-Register oder eine 64 (128)-BitVariable sein, Operand1 muss ein 
;- MMX (XMM)-Register sein
;- Es wird Word-weise der Durchschnittswert ermittelt. Man beachte, dass "aufgerundet" wird, da 
;-  die Word-Summe vor der Division durch 2 um 1 inkrementiert wird 
;- Die Words werden als vorzeichenlos interpretiert
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- Beispiel mit MMX-Register
!movq mm0,[X]
!pavgw mm0,[Y]
!movq [R],mm0
!emms                        ;da MMX-Register benutzt wurden

MessageRequester("PAVGW   MMX-Beispiel, z.B. 1D1Eh ist ((0708h + 3333h) + 1h) / 2", HexQ(PeekQ(?R)))  ;Hex nur wegen deutlicherer Darstellung

;- Beispiel mit XMM-Register
!xorps xmm0,xmm0             ;XMM0 = Operand1 zur Vereinfachung auf Null setzen
!pavgw xmm0,dqword[X]        ;also X (wird unteres Quad-Word) und Y (wird oberes Quad-Word) laden
!movups dqword[R],xmm0

MessageRequester("PAVGW   XMM-Beispiel, z.B. 199Ah ist ((0h + 3333h) + 1h) / 2", RSet(HexQ(PeekQ(?R + 8)),16,"0") + RSet(HexQ(PeekQ(?R)),16,"0"))
;                                                        Op.1  Op.2                   oberes Quad-Word                   unteres Quad-Word

End 

!section '.data' Data readable writeable
!X DQ 1102030405060708h
!Y DQ 3333333333333333h
R:
!R DQ ?
!times 1 DQ ?                          ;2,Quad-Word fr XMM-Beispiel
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableAsm
; DisableDebugger