;- Beispiel fr RCPPS
;- Reciprocal of Packed Single-FP Values
;- SSE - bildet jeweils den Kehrwert aus den vier gepackten Fliesskommazahlen einfacher Genauigkeit
;-  des 2.Operanden und speichert die Ergebnisse im 1.Operanden
;- Dateiname 3210.pb
;- "Helle" Klaus Helbing, 17.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Die Rundungskontrolle des MXCSR-Registers spielt keine Rolle
;- Der relative Fehler liegt bei ca. <= 1.5*2^-12 (lt.Intel)
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

Global A.f = 1234.5
Global B.f = 678.9
Global C.f = 5432.1
Global D.f = 987.6

;- die 4 FPs (A bis D) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;die beiden unteren Double-Words von XMM1 werden in die beiden oberen
                             ; Double-Words von XMM2 kopiert
!rcpps xmm0,xmm2             ;bildet den Kehrwert jeder der 4 FP-Zahlen

!movups dqword[R],xmm0

MessageRequester("RCPPS    Kehrwert von A", StrF(PeekF(?R + 12)))
MessageRequester("RCPPS    Kehrwert von B", StrF(PeekF(?R + 8)))
MessageRequester("RCPPS    Kehrwert von C", StrF(PeekF(?R + 4)))
MessageRequester("RCPPS    Kehrwert von D", StrF(PeekF(?R)))

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 7
; Folding = -
; EnableAsm
; DisableDebugger