;- Beispiel fr CMPPS
;- Compare Packed Single-FP Values
;- SSE - vergleicht jeweils die korrespondierenden gepackten Fliesskommazahlen einfacher Genauigkeit
;-  der beiden ersten Operanden und speichert die Ergebnisse im ersten Operanden. Der dritte Operand
;-  gibt die Art des Vergleiches vor
;- Dateiname 3400.pb
;- "Helle" Klaus Helbing, 17.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein,
;-  Operand3 muss eine 8-Bit-Konstante sein
;-  Ist der Vergleich wahr, werden alle Bits des Double-Words auf 1 gesetzt, bei falsch auf 0
;-  Werte fr Operand3: 0 = Vergleich, ob gleich
;-                      1 =     "    , ob kleiner
;-                      2 =     "    , ob kleiner oder gleich
;-                      3 =     "    , ob ungeordnet (mindestens eine Zahl ist ungltig)
;-                      4 =     "    , ob nicht gleich
;-                      5 =     "    , ob grsser gleich
;-                      6 =     "    , ob grsser
;-                      7 =     "    , ob geordnet (beide Zahlen sind gltig)
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

Global A.f = 1234.5
Global B.f = 678.9
Global C.f = 5432.1
Global D.f = 987.6
Global E.f = 1234.5

;- die 4 FPs (A bis D) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;die beiden unteren Double-Words von XMM1 werden in die beiden oberen
                             ; Double-Words von XMM2 kopiert
!movss xmm0,[v_E]
!shufps xmm0,xmm0,0          ;alle 4 Double-Words erhalten damit den Wert von E  

!cmpps xmm2,xmm0,2           ;vergleicht jede der 4 FP-Zahlen mit 1234.5; 2 = kleiner gleich 

!movups dqword[R],xmm2

MessageRequester("CMPPS   A <= E ?  Ja = FFFFFFFF, Nein = 0", Hex(PeekL(?R + 12)))
MessageRequester("CMPPS   B <= E ?  Ja = FFFFFFFF, Nein = 0", Hex(PeekL(?R + 8)))
MessageRequester("CMPPS   C <= E ?  Ja = FFFFFFFF, Nein = 0", Hex(PeekL(?R + 4)))
MessageRequester("CMPPS   D <= E ?  Ja = FFFFFFFF, Nein = 0", Hex(PeekL(?R)))

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 6
; FirstLine = 6
; Folding = -
; EnableAsm
; DisableDebugger