;- Beispiel fr COMISS
;- Compare Scalar Single-FP Values and Set Flags
;- SSE - vergleicht die beiden (untersten) Fliesskommazahlen einfacher Genauigkeit der beiden
;-  Operanden und setzt entsprechend dem Ergebnis Flags. Die Operanden werden nicht verndert
;- Dateiname 3402.pb
;- "Helle" Klaus Helbing, 11.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 32-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Entsprechend dem Vergleich wird das Zero-, Parity- und Carry-Flag gesetzt 
;- Overflow-, Sign- und Auxilliary-Flag werden gelscht
;- Es gilt folgende Zuordnung:
;-     Vergleich    Zero-Flag (Bit 6)    Parity-Flag (Bit 2)    Carry-Flag (Bit 0)
;-      grsser           0                      0                     0
;-      kleiner           0                      0                     1 
;-      gleich            1                      0                     0
;-      ungeordnet        1                      1                     1    beide Operanden sind eine NaN  
;- Im Gegensatz zu UCOMISS wird eine Invalid-Operation-Exception ausgelst, wenn ein Operand eine SNaN
;-  oder QNaN enthlt (UCOMISS: Nur SNaN)

Global A.f = 1234.5
Global B.f = 678.9
Global F0.b
Global F1.b

!xor eax,eax                 ;nur wegen Ausgangsstellung des Flag-Registers, setzt u.a. das Zero-Flag
!lahf                        ;unteres Byte des Flag-Words in AH laden
!mov [v_F0],ah
!movss xmm0,[v_B]
!comiss xmm0,[v_A] 
!lahf                        ;unteres Byte des Flag-Words in AH laden
!mov [v_F1],ah

MessageRequester("COMISS   Vergleicht B mit A, lscht hier u.a. das Zero- und setzt das Carry-Flag", RSet(Bin(F0), 8, "0") + #CRLF$ + RSet(Bin(F1), 8, "0"))

End
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 31
; Folding = -
; EnableAsm
; DisableDebugger