;- Beispiel fr MINPS
;- Packed Single-FP Minimum
;- SSE - vergleicht jeweils die korrespondierenden gepackten Fliesskommazahlen einfacher Genauigkeit
;-  der beiden Operanden und speichert die kleinere im ersten Operanden
;- Dateiname 3405.pb
;- "Helle" Klaus Helbing, 17.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

Global A.f = 1234.5
Global B.f = 678.9
Global C.f = 5432.1
Global D.f = 987.6
Global E.f = 1234.5

;- die 4 FPs (A bis D) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;die beiden unteren Double-Words von XMM1 werden in die beiden oberen
                             ; Double-Words von XMM2 kopiert
!movss xmm0,[v_E]
!shufps xmm0,xmm0,0          ;alle 4 Double-Words erhalten damit den Wert von E  

!minps xmm2,xmm0             ;vergleicht jede der 4 FP-Zahlen mit 1234.5 

!movups dqword[R],xmm2

MessageRequester("MINPS   Vergleicht A und E auf Minimum", StrF(PeekF(?R + 12)))
MessageRequester("MINPS   Vergleicht B und E auf Minimum", StrF(PeekF(?R + 8)))
MessageRequester("MINPS   Vergleicht C und E auf Minimum", StrF(PeekF(?R + 4)))
MessageRequester("MINPS   Vergleicht D und E auf Minimum", StrF(PeekF(?R)))

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableAsm
; DisableDebugger