;- Beispiel fr SHUFPS
;- Shuffle Single FP-Values
;- SSE - kopiert 2 Double-Words von Operand1 in das untere Quad-Word von Operand1 und 2 Double-Words
;-  von Operand2 in das obere Quad-Word von Operand1. Die Reihenfolge bestimmt Operand3
;- Dateiname 3501.pb
;- "Helle" Klaus Helbing, 13.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein 
;- Operand3 muss eine 8-Bit-Konstante sein
;- Zuordnung (der Wert der 2 Bits von Operand3 liegt jeweils zwischen 0 und 3):  
;-  Operand1[Bits 0-31]   = Wert Operand3[Bits 0 und 1] * 32 = Zeiger auf Bit-Adresse von Operand1   
;-  Operand1[Bits 32-63]  = Wert Operand3[Bits 2 und 3] * 32 = Zeiger auf Bit-Adresse von Operand1
;-  Operand1[Bits 64-95]  = Wert Operand3[Bits 4 und 5] * 32 = Zeiger auf Bit-Adresse von Operand2
;-  Operand1[Bits 96-127] = Wert Operand3[Bits 6 und 7] * 32 = Zeiger auf Bit-Adresse von Operand2
;-  Bit-Adresse knnen also die Werte  0, 32, 64 und 96 sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!movups xmm0,dqword[X]
!shufps xmm0,dqword[Y],10100111b      
!movups dqword[R],xmm0 

MessageRequester("SHUFPS", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                          oberes Quad-Word           unteres Quad-Word   
;- Eine schne Mglichkeit ist das "Fllen" von "grossen" Registern mit einem gleichen Wert
!movups xmm0,dqword[X] 
!shufps xmm0,xmm0,0          ;"0" ldt das untere Double-Word (hier 03030404h) in alle anderen Double-Words    
!movups dqword[R],xmm0 

MessageRequester("SHUFPS", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))   
;                          oberes Quad-Word           unteres Quad-Word   
End

!section '.data' Data readable writeable
!X DQ       0A101020203030404h         ;unteres Quad-Word von X (in Operand1)
!times 1 DQ 0B123456789012345h         ;oberes Quad-Word von X (in Operand1)
!Y DQ       0C101020203030404h         ;unteres Quad-Word von Y (Operand2)
!times 1 DQ 0D505060607070808h         ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 24
; Folding = -
; EnableAsm
; DisableDebugger