;- Beispiel fr MOVAPD
;- Move Aligned Packed Double-Precision Floating-Point Values 
;- SSE2 - kopiert den zweiten Operanden in den ersten
;- Bei Verwendung einer Variable muss diese an einer 16-Byte-Adresse ausgerichtet sein
;- Dateiname 4001.pb
;- "Helle" Klaus Helbing, 21.06.2007, PB v4.02
;- Die Operanden knnen 128-Bit-Register oder 128-Bit-Variablen sein. Ein Operand muss ein Register sein
;- Wenn kein 16-Byte-Alignment vorhanden ist muss MOVUPD verwendet werden (ist aber langsamer)
;- Es sollte darauf geachtet werden, fr welche nachfolgenden Operationen ein MOV-Befehl durchgefhrt
;-  wurde. Sind die Aktionen vom Typ "Double-Precision FP", sollten die SSE2-FP-Befehle verwendet werden.
;-  Analoges gilt fr "Single-Precision FP", dann sind die SSE-FP-Befehle einzusetzen.
;-  Fr MOV-Integer sollten z.B. MOVDQA bzw. MOVDQU verwendet werden.
;-  Ansonsten kann es zu "latency penalties", also Verzgerungen im Programmablauf, kommen.
;-  Diese "latency penalties" treten aber nur beim Kopieren vom Speicher in XMM-Register auf, nicht
;-  anders herum

!movdqu xmm0,dqword[X]       ;ldt X (128 Bit), also beide Double-Precision-Floating-Points
!movapd dqword[R],xmm0
 
MessageRequester("MOVAPD", StrD(PeekD(?R)) + #LFCR$ + StrD(PeekD(?R+8)))

End

!section '.data' Data readable writeable
;!A DB ?                     ;hiermit kann man Unalignment testen!
;16-Byte-Alignment ist hier am Anfang der Data-Section garantiert
!X DQ 123456.789             ;unteres Double-Precision-Floating-Point von X (in Operand2)
!  DQ 98765.4321             ;oberes Double-Precision-Floating-Point von X (in Operand2)
R:
!R DQ ?                      ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!  DQ ?                      ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 24
; Folding = -
; EnableAsm
; DisableDebugger