;- Beispiel fr MOVDQU
;- Move Unaligned Double-Quad-Word 
;- SSE2 - kopiert den zweiten Operanden in den ersten
;- Bei Verwendung einer Variable muss diese nicht an einer 16-Byte-Adresse ausgerichtet sein
;- Dateiname 4003.pb
;- "Helle" Klaus Helbing, 08.01.2007, PB v4.02
;- Die Operanden knnen 128-Bit-Register oder 128-Bit-Variablen sein. Ein Operand muss ein Register sein
;- Wenn 16-Byte-Alignment vorhanden ist sollte MOVDQA verwendet werden (ist schneller)
;- Es sollte darauf geachtet werden, fr welche nachfolgenden Operationen ein MOV-Befehl durchgefhrt
;-  wurde. Sind die Aktionen vom Typ "Double-Precision FP", sollten die SSE2-FP-Befehle verwendet werden.
;-  Analoges gilt fr "Single-Precision FP", dann sind die SSE-FP-Befehle einzusetzen.
;-  Fr MOV-Integer sollten z.B. MOVDQA bzw. MOVDQU verwendet werden.
;-  Ansonsten kann es zu "latency penalties", also Verzgerungen im Programmablauf, kommen.
;-  Diese "latency penalties" treten aber nur beim Kopieren vom Speicher in XMM-Register auf, nicht
;-  anders herum

!movdqu xmm0,dqword[X]       ;ldt X (128 Bit)
!movdqu dqword[R],xmm0
 
MessageRequester("MOVDQU", HexQ(PeekQ(?R+8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                          oberes Quad-Word           unteres Quad-Word
End

!section '.data' Data readable writeable
!A DB ?                                ;Unalignment erzeugen
!X DQ       101020203030404h           ;16-Byte-Alignment ist hier am Anfang der Data-Section garantiert
!times 1 DQ 505060607070808h           ;oberes Quad-Word von X (in Operand2)
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 19
; Folding = -
; EnableAsm
; DisableDebugger