;- Beispiel fr MOVNTPD
;- Move Packed Double-Precision Floating-Point Using Non-Temporal Hint 
;- SSE2 - kopiert den zweiten Operanden (XMM-Register) mit zwei Double-Fliesskomma-Zahlen in den
;   ersten Operanden (128-Bit-Variable) ohne die Daten zu cachen
;- Dateiname 4010.pb
;- "Helle" Klaus Helbing, 21.06.2007, PB v4.02
;- Operand2 muss ein XMM-Register und Operand1 muss eine 128-Bit-Variable sein
;- Bei den Cache-Umgehungsbefehlen sollte vorher immer SFENCE bzw. MFENCE ausgefhrt werden um sicher 
;-  zu sein, das sich der Speicher whrend der Ausfhrung nicht ndert
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!movupd xmm0,dqword[X]       ;ldt X (128 Bit), also beide Double-Precision-Floating-Points
!sfence                      ;evtl. noch anstehende Speicher-Schreib-Vorgnge abarbeiten
!movntpd dqword[R],xmm0
 
MessageRequester("MOVNTPD", StrD(PeekD(?R)) + #LFCR$ + StrD(PeekD(?R+8)))

End

!section '.data' Data readable writeable
!X DQ 123456.789             ;unteres Double-Precision-Floating-Point von X (in Operand2)
!  DQ 98765.4321             ;oberes Double-Precision-Floating-Point von X (in Operand2)
R:
!R DQ ?                      ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!  DQ ?                      ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 17
; Folding = -
; EnableAsm
; DisableDebugger