;- Beispiel fr MOVUPD
;- Move Unaligned Packed Double-Precision Floating-Point Values 
;- SSE2 - kopiert den zweiten Operanden in den ersten
;- Bei Verwendung einer Variable muss diese nicht an einer 16-Byte-Adresse ausgerichtet sein
;- Dateiname 4013.pb
;- "Helle" Klaus Helbing, 21.06.2007, PB v4.02
;- Die Operanden knnen 128-Bit-Register oder 128-Bit-Variablen sein. Ein Operand muss ein Register sein
;- Wenn 16-Byte-Alignment vorhanden ist sollte MOVAPD verwendet werden (ist schneller)
;- Ab SSE2 sollte darauf geachtet werden, fr welche nachfolgenden Operationen ein MOV-Befehl durchgefhrt
;-  wurde. Sind die Aktionen vom Typ "Double-Precision FP", sollten die SSE2-FP-Befehle verwendet werden.
;-  Analoges gilt fr "Single-Precision FP", dann sind die SSE-FP-Befehle einzusetzen.
;-  Fr MOV-Integer sollten z.B. MOVDQA bzw. MOVDQU verwendet werden.
;-  Ansonsten kann es zu "latency penalties", also Verzgerungen im Programmablauf, kommen.
;-  Diese "latency penalties" treten aber nur beim Kopieren vom Speicher in XMM-Register auf, nicht
;-  anders herum


!movupd xmm0,dqword[X]       ;ldt X (128 Bit)
!movupd dqword[R],xmm0
 
MessageRequester("MOVUPD", StrD(PeekD(?R)) + #LFCR$ + StrD(PeekD(?R+8)))

End

!section '.data' Data readable writeable
;16-Byte-Alignment ist hier am Anfang der Data-Section garantiert
!A DB ?                      ;Unalignment erzeugen
!X DQ 123456.789             ;unteres Double-Precision-Floating-Point von X (in Operand2)
!  DQ 98765.4321             ;oberes Double-Precision-Floating-Point von X (in Operand2)
R:
!R DQ ?                      ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!  DQ ?                      ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 20
; Folding = -
; EnableAsm
; DisableDebugger