;- Beispiel fr CVTDQ2PS
;- Convert Packed Double-Word-Integer to Packed Single-FP 
;- SSE2 - konvertiert die vier vorzeichenbehafteten Integer-Double-Words aus dem zweiten Operanden
;-  in vier Fliesskommazahlen einfacher Genauigkeit in den ersten Operanden
;- Dateiname 4101.pb
;- "Helle" Klaus Helbing, 17.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Ist die Konvertierung ungenau wird gemss Angabe im MXCSR-Register gerundet

Global A.l = 12345
Global B.l = -6789
Global C.l = 54321
Global D.l = 9876

;- die 4 Integers (A bis D) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;die beiden unteren Double-Words von XMM1 werden in die beiden oberen
                             ; Double-Words von XMM2 kopiert
!cvtdq2ps xmm0,xmm2

!movups dqword[R],xmm0

MessageRequester("CVTDQ2PS", StrF(PeekF(?R + 12)))    ;4 Byte 1.Float-Zahl
MessageRequester("CVTDQ2PS", StrF(PeekF(?R + 8)))     ;4 Byte 2.Float-Zahl
MessageRequester("CVTDQ2PS", StrF(PeekF(?R + 4)))     ;4 Byte 3.Float-Zahl
MessageRequester("CVTDQ2PS", StrF(PeekF(?R)))         ;4 Byte 4.Float-Zahl

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableAsm
; DisableDebugger