;- Beispiel fr CVTPD2PI
;- Convert Packed Double-Precision Floating-Point Values to Packed Double-Word Integers
;- SSE2 - konvertiert die zwei Fliesskommazahlen doppelter Genauigkeit des zweiten Operanden in
;-  zwei vorzeichenbehaftete Integer-Double-Words in den ersten Operanden (MMX-Register)
;- Dateiname 4103.pb
;- "Helle" Klaus Helbing, 08.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein MMX-Register sein
;- Ist die Konvertierung ungenau wird gemss Angabe im MXCSR-Register gerundet
;- Ist das Ergebnis grsser als ein vorzeichenbehaftetes Integer-Double-Word sein kann, wird 80000000h
;-  als Wert fr unendlich zurckgeschrieben
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein! 

Global A.l
Global B.l

!cvtpd2pi mm0,dqword[X]
!movd [v_A],mm0
!psrlq mm0,32                ;um ein Double-Word nach rechts schieben zum Auslesen mittels MOVD
!movd [v_B],mm0
!emms                        ;da MMX-Register benutzt wurden

MessageRequester("CVTPD2PI", Str(A))
MessageRequester("CVTPD2PI", Str(B))

End

!section '.data' Data readable writeable
!X DQ       1122330404.0               ;unteres Quad-Word von X (Operand2)
!times 1 DQ  556677808.0               ;oberes Quad-Word von X (Operand2)
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 10
; Folding = -
; EnableAsm
; DisableDebugger