;- Beispiel fr CVTPD2PS
;- Convert Packed Double-Precision Floating-Point Values to Packed Single-Precision Floating-Point
;- SSE2 - konvertiert die zwei Fliesskommazahlen doppelter Genauigkeit des zweiten Operanden in zwei
;-  Fliesskommazahlen einfacher Genauigkeit in den ersten Operanden
;- Dateiname 4104.pb
;- "Helle" Klaus Helbing, 08.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Von Operand1 wird das untere Quad-Word benutzt, das obere wird auf Null gesetzt
;- Ist die Konvertierung ungenau wird gemss Angabe im MXCSR-Register gerundet
;- Man beachte die auftretenden Ungenauigkeiten!
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein! 

Global A.f
Global B.f

!cvtpd2ps xmm0,dqword[X]
!movd [v_A],xmm0
!psrlq xmm0,32               ;um ein Double-Word nach rechts schieben zum Auslesen mittels MOVD
!movd [v_B],xmm0

MessageRequester("CVTPD2PS", StrF(A))
MessageRequester("CVTPD2PS", StrF(B))

End

!section '.data' Data readable writeable
!X DQ       1122330404.0               ;unteres Quad-Word von X (Operand2)
!times 1 DQ  556677808.0               ;oberes Quad-Word von X (Operand2)
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 10
; Folding = -
; EnableAsm
; DisableDebugger