;- Beispiel fr CVTPS2DQ
;- Convert Packed Single-FP to Packed Double-Word-Integer  
;- SSE2 - konvertiert die vier Fliesskommazahlen einfacher Genauigkeit aus dem zweiten Operanden in
;-  vier vorzeichenbehaftete Integer-Double-Words in den ersten Operanden
;- Dateiname 4106.pb
;- "Helle" Klaus Helbing, 17.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Ist die Konvertierung ungenau wird gemss Angabe im MXCSR-Register gerundet
;- Ist das Ergebnis grsser als ein vorzeichenbehaftetes Integer-Double-Word sein kann, wird 80000000h
;-  als Wert fr unendlich zurckgeschrieben
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein! 

Global A.f = 12345.1
Global B.f = -6789.2
Global C.f = 54321.8
Global D.f = 9876.5

;- die 4 Single-Floats (A bis D) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;die beiden unteren Double-Words von XMM1 werden in die beiden oberen
                             ; Double-Words von XMM2 kopiert
!cvtps2dq xmm0,xmm2

!movdqu dqword[R],xmm0

MessageRequester("CVTPS2DQ", Str(PeekL(?R + 12)))     ;4 Byte 1.Integer-Zahl
MessageRequester("CVTPS2DQ", Str(PeekL(?R + 8)))      ;4 Byte 2.Integer-Zahl
MessageRequester("CVTPS2DQ", Str(PeekL(?R + 4)))      ;4 Byte 3.Integer-Zahl
MessageRequester("CVTPS2DQ", Str(PeekL(?R)))          ;4 Byte 4.Integer-Zahl

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableAsm
; DisableDebugger