;- Beispiel fr CVTPS2PD
;- Convert Packed Single-FP to Packed Double-FP 
;- SSE2 - konvertiert die zwei Fliesskommazahlen einfacher Genauigkeit des zweiten Operanden in zwei
;-  Fliesskommazahlen doppelter Genauigkeit in den ersten Operanden
;- Dateiname 4107.pb
;- "Helle" Klaus Helbing, 17.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 64-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Ist Operand2 ein XMM-Register, wird das untere Quad-Word benutzt
;- Man beachte die auftretenden Ungenauigkeiten!

Global A.f = 12345.1
Global B.f = -6789.2

;- die 2 Single-Floats (A und B) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!cvtps2pd xmm0,xmm1

!movupd dqword[R],xmm0

MessageRequester("CVTPS2PD", StrD(PeekD(?R + 8)))      ;8 Byte 1.Double-FP-Zahl
MessageRequester("CVTPS2PD", StrD(PeekD(?R)))          ;8 Byte 2.Double-FP-Zahl

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableAsm
; DisableDebugger