;- Beispiel fr MULPD
;- Multiply Packed Double-FP Values
;- SSE2 - multipliziert jeweils die korrespondierenden gepackten Fliesskommazahlen doppelter Genauigkeit
;-  der beiden Operanden und speichert die Ergebnisse im ersten Operanden
;- Dateiname 4204.pb
;- "Helle" Klaus Helbing, 08.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein! 

!movupd xmm0,dqword[X]       ;MOVUPD weil nachfolgender Befehl ein DP-FP-Befehl ist (schneller)
!mulpd xmm0,dqword[Y]
!movupd dqword[R],xmm0

MessageRequester("MULPD  Produkt obere Quad-Words", StrD(PeekD(?R + 8)))
MessageRequester("MULPD  Produkt untere Quad-Words", StrD(PeekD(?R)))

End

!section '.data' Data readable writeable
!X DQ       1122330404.345             ;unteres Quad-Word von X (in Operand1)   
!times 1 DQ    6677808.678             ;oberes Quad-Word von X (in Operand1)
!Y DQ         43565676.65678           ;unteres Quad-Word von Y (Operand2)
!times 1 DQ       9878.002             ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 8
; Folding = -
; EnableAsm
; DisableDebugger