;- Beispiel fr PMULUDQ
;- Multiply Packed Unsigned Double-Word-Integers
;- SSE2 - multipliziert jeweils ein (64-Bit) bzw. zwei (128-Bit) Double-Word(s) der beiden Operanden
;-  miteinander und speichert das Ergebnis jeweils als Quad-Word im ersten Operanden
;- Dateiname 4207.pb
;- "Helle" Klaus Helbing, 08.01.2007, PB v4.02
;- Operand2 kann ein Register oder eine Variable sein, Operand1 muss ein Register sein 
;- Es gibt die Kombinationen MMX-Register/64-Bit-Variable und XMM-Register/128-Bit-Variable
;- 64-Bit: Die beiden unteren Double-Words werden multipliziert und als Quad-Word im MMX-Register
;-  (Operand1) gespeichert
;- 128-Bit: Die beiden unteren (ersten) und die dritten Double-Words werden multipliziert und als zwei
;-  Quad-Words im XMM-Register (Operand1) gespeichert
;- Die Operanden sind vorzeichenlos
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;Beispiel mit MMX-Register
!movq mm0,[X]
!pmuludq mm0,[Y]
!movq [R],mm0                ;multipliziert 22222222h * 66666666h
!emms

MessageRequester("PMULUDQ mit MMX-Register", HexQ(PeekQ(?R)))

;Beispiel mit XMM-Register
!movdqu xmm0,dqword[X]       ;MOVDQU weil nachfolgender Befehl ein Integer-Befehl ist (schneller)
!pmuludq xmm0,dqword[Y]
!movdqu dqword[R],xmm0       ;multipliziert 22222222h * 66666666h und 44444444h * 88888888h

MessageRequester("PMULUDQ mit XMM-Register", HexQ(PeekQ(?R + 8)) + "  und  " + HexQ(PeekQ(?R)))
;                                            oberes Quad-Word                  unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ        1111111122222222h         ;unteres Quad-Word von X (in Operand1)
!times 1 DQ  3333333344444444h         ;oberes Quad-Word von X (in Operand1)
!Y DQ        5555555566666666h         ;unteres Quad-Word von Y (Operand2)
!times 1 DQ  7777777788888888h         ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableAsm
; DisableDebugger