;- Beispiel fr PSUBQ
;- Subtract Packed Quad-Word-Integers
;- SSE2 - subtrahiert die korrespondierenden Quad-Words der beiden Operanden in den ersten Operanden,
;-  berlufe finden nur innerhalb der Quad-Words statt, werden aber nicht signalisiert
;- Dateiname 4208.pb
;- "Helle" Klaus Helbing, 08.01.2007, PB v4.02
;- Operand2 kann ein Register oder eine Variable sein, Operand1 muss ein Register sein 
;- Es gibt die Kombinationen MMX-Register/64-Bit-Variable und XMM-Register/128-Bit-Variable
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;Beispiel mit MMX-Register
!movq mm0,[X]
!psubq mm0,[Y]
!movq [R],mm0
!emms

MessageRequester("PSUBQ mit MMX-Register", StrQ(PeekQ(?R)))

;Beispiel mit XMM-Register
!movdqu xmm0,dqword[X]       ;MOVDQU weil nachfolgender Befehl ein Integer-Befehl ist (schneller)
!psubq xmm0,dqword[Y]
!movdqu dqword[R],xmm0

MessageRequester("PSUBQ mit XMM-Register", StrQ(PeekQ(?R + 8)) + "  und  " + StrQ(PeekQ(?R)))
;                                          oberes Quad-Word                  unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ        11223344                  ;unteres Quad-Word von X (in Operand1)
!times 1 DQ  43210987                  ;oberes Quad-Word von X (in Operand1)
!Y DQ        55667788                  ;unteres Quad-Word von Y (Operand2)
!times 1 DQ   1234567                  ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 24
; Folding = -
; EnableAsm
; DisableDebugger