;- Beispiel fr CMPPD
;- Compare Packed Double-FP Values
;- SSE2 - vergleicht jeweils die korrespondierenden gepackten Fliesskommazahlen doppelter Genauigkeit
;-  der beiden ersten Operanden und speichert die Ergebnisse im ersten Operanden. Der dritte Operand
;-  gibt die Art des Vergleiches vor
;- Dateiname 4500.pb
;- "Helle" Klaus Helbing, 07.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein,
;-  Operand3 muss eine 8-Bit-Konstante sein
;-  Ist der Vergleich wahr, werden alle Bits des Quad-Words auf 1 gesetzt, bei falsch auf 0
;-  Werte fr Operand3: 0 = Vergleich, ob gleich
;-                      1 =     "    , ob kleiner
;-                      2 =     "    , ob kleiner oder gleich
;-                      3 =     "    , ob ungeordnet (mindestens eine Zahl ist ungltig)
;-                      4 =     "    , ob nicht gleich
;-                      5 =     "    , ob grsser gleich
;-                      6 =     "    , ob grsser
;-                      7 =     "    , ob geordnet (beide Zahlen sind gltig)
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- die Double-FPs in XMM-Register schreiben
!movlpd xmm0,[A]
!movhpd xmm0,[B] 
!movlpd xmm1,[C]             ;C in beide Quad-Words
!movhpd xmm1,[C]

!cmppd xmm0,xmm1,2           ;vergleicht jede der 2 FP-Zahlen mit C; 2 = kleiner oder gleich 

!movupd dqword[R],xmm0

MessageRequester("CMPPD   B <= C = falsch = 0", HexQ(PeekQ(?R + 8)))
MessageRequester("CMPPD   A <= C = wahr = FFFFFFFFFFFFFFFF", HexQ(PeekQ(?R)))

End

!section '.data' Data readable writeable
!A DQ 123456789012.123
!B DQ 234567891234.987
!C DQ 156789234567.345
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 31
; Folding = -
; EnableAsm
; DisableDebugger