;- Beispiel fr MINPD
;- Minimum Packed Double-FP Values
;- SSE2 - vergleicht jeweils die korrespondierenden gepackten DP-FPs der beiden Operanden und
;-  schreibt die kleinere in das entsprechende Quad-Word von Operand1
;- Dateiname 4505.pb
;- "Helle" Klaus Helbing, 07.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein,
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- die Double-FPs in XMM-Register schreiben
!movlpd xmm0,[A]
!movhpd xmm0,[B] 
!movlpd xmm1,[C]             ;C in beide Quad-Words
!movhpd xmm1,[C]

!minpd xmm0,xmm1             ;vergleicht jede der 2 FP-Zahlen mit C 

!movupd dqword[R],xmm0

MessageRequester("MINPD", StrD(PeekD(?R + 8)))   ;8 Byte oberes Quad-Word
MessageRequester("MINPD", StrD(PeekD(?R)))       ;8 Byte unteres Quad-Word

End

!section '.data' Data readable writeable
!A DQ 123456789012.123
!B DQ 234567891234.987
!C DQ 156789234567.345
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 20
; Folding = -
; EnableAsm
; DisableDebugger