;- Beispiel fr UCOMISD
;- Unordered Compare Scalar Double-FP Values and Set Flags
;- SSE2 - vergleicht die beiden (untersten) Fliesskommazahlen einfacher Genauigkeit der beiden
;-  Operanden und setzt entsprechend dem Ergebnis Flags. Die Operanden werden nicht verndert
;- Dateiname 4507.pb
;- "Helle" Klaus Helbing, 07.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 64-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Entsprechend dem Vergleich wird das Zero-, Parity- und Carry-Flag gesetzt 
;- Overflow-, Sign- und Auxilliary-Flag werden gelscht
;- Es gilt folgende Zuordnung:
;-     Vergleich    Zero-Flag (Bit 6)    Parity-Flag (Bit 2)    Carry-Flag (Bit 0)
;-      grsser           0                      0                     0
;-      kleiner           0                      0                     1 
;-      gleich            1                      0                     0
;-      ungeordnet        1                      1                     1    beide Operanden sind eine NaN 
;- Im Gegensatz zu COMISD wird eine Invalid-Operation-Exception ausgelst, wenn ein Operand eine SNaN
;-  enthlt (COMISD: SNaN oder QNaN)

Global F0.b
Global F1.b

!xor eax,eax                 ;nur wegen Ausgangsstellung des Flag-Registers
!lahf                        ;unteres Byte des Flag-Words in AH laden
!mov [v_F0],ah
!movlpd xmm0,[A]

!ucomisd xmm1,[B] 

!lahf                        ;unteres Byte des Flag-Words in AH laden
!mov [v_F1],ah

MessageRequester("UCOMISD", RSet(Bin(F0), 8, "0") + #CRLF$ + RSet(Bin(F1), 8, "0"))

End

!section '.data' Data readable writeable
!A DQ 123456789012.123
!B DQ 234567891234.987
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 30
; Folding = -
; EnableAsm
; DisableDebugger