;- Beispiel fr PSHUFD
;- Shuffle Packed Double-Words
;- SSE2 - kopiert die vier Double-Words des zweiten Operanden in anderer Reihenfolge in den ersten
;-  Operanden. Die Reihenfolge bestimmt der dritte Operand
;- Dateiname 4600.pb
;- "Helle" Klaus Helbing, 12.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein,
;-  Operand3 muss eine 8-Bit-Konstante sein
;- Werte knnen mehrfach oder gar nicht kopiert werden!
;- Zuordnung (der Wert der 2 Bits von Operand3 liegt jeweils zwischen 0 und 3):  
;-  Operand1[Bits 0-31]   = Wert Operand3[Bits 0 und 1] * 32 = Zeiger auf Bit-Adresse von Operand2   
;-  Operand1[Bits 32-63]  = Wert Operand3[Bits 2 und 3] * 32 = Zeiger auf Bit-Adresse von Operand2
;-  Operand1[Bits 64-95]  = Wert Operand3[Bits 4 und 5] * 32 = Zeiger auf Bit-Adresse von Operand2
;-  Operand1[Bits 96-127] = Wert Operand3[Bits 6 und 7] * 32 = Zeiger auf Bit-Adresse von Operand2
;-  Bit-Adresse knnen also die Werte  0, 32, 64 und 96 sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!pshufd xmm0,dqword[X],10100111b
!movdqu dqword[R],xmm0

MessageRequester("PSHUFD", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                          oberes Quad-Word           unteres Quad-Word
;- Eine schne Mglichkeit ist das "Fllen" von "grossen" Registern mit einem gleichen Wert
!pshufd xmm0,dqword[X],0
!movdqu dqword[R],xmm0

MessageRequester("PSHUFD", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                          oberes Quad-Word           unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ       1122334455667788h           ;unteres Quad-Word von X (Operand2)
!times 1 DQ 9900AABBCCDDEEFFh           ;oberes Quad-Word von X (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableAsm
; DisableDebugger