;- Beispiel fr PSHUFLW
;- Shuffle Packed Low-Words
;- SSE2 - kopiert die vier unteren Words des zweiten Operanden in anderer Reihenfolge in das untere
;-  Quad-Word des ersten Operanden. Die Reihenfolge bestimmt der dritte Operand
;- Dateiname 4602.pb
;- "Helle" Klaus Helbing, 12.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein,
;-  Operand3 muss eine 8-Bit-Konstante sein
;- Werte knnen mehrfach oder gar nicht kopiert werden!
;- Das obere Quad-Word von Operand2 wird unverndert in das obere Quad-Word von Operand1 kopiert!
;- Zuordnung (der Wert der 2 Bits von Operand3 liegt jeweils zwischen 0 und 3):  
;-  Operand1[Bits 0-15]  = Wert Operand3[Bits 0 und 1] * 16 = Zeiger auf Bit-Adresse von Operand2   
;-  Operand1[Bits 16-31] = Wert Operand3[Bits 2 und 3] * 16 = Zeiger auf Bit-Adresse von Operand2
;-  Operand1[Bits 32-47] = Wert Operand3[Bits 4 und 5] * 16 = Zeiger auf Bit-Adresse von Operand2
;-  Operand1[Bits 48-63] = Wert Operand3[Bits 6 und 7] * 16 = Zeiger auf Bit-Adresse von Operand2
;-  Bit-Adresse knnen also die Werte  0, 16, 32 und 48 sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!pshuflw xmm0,dqword[X],10100111b
!movdqu dqword[R],xmm0

MessageRequester("PSHUFLW", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                           oberes Quad-Word           unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ       1122334455667788h          ;unteres Quad-Word von X (Operand2)
!times 1 DQ 9900AABBCCDDEEFFh          ;oberes Quad-Word von X (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 10
; Folding = -
; EnableAsm
; DisableDebugger