;- Beispiel fr SHUFPD
;- Shuffle Packed Double-Precision Floating-Point Values
;- SSE2 - kopiert eines der Quad-Words von Operand1 in das untere Quad-Word von Operand1 und eines
;-  der Quad-Words von Operand2 in das obere Quad-Word von Operand1. Die Reihenfolge bestimmt Op.3
;- Dateiname 4603.pb
;- "Helle" Klaus Helbing, 12.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein,
;-  Operand3 muss eine 8-Bit-Konstante sein
;- Operand3: Bit 0 (fr unteres Quad-Word) und 1 (fr oberes Quad-Word) bestimmen, welches Quad-Word
;-  jeweils kopiert wird: Bit = 0 = unteres Quad-Word, Bit = 1 = oberes Quad-Word wird kopiert
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!movupd xmm0,dqword[X]       ;MOVUPD weil nachfolgender Befehl ein DP-FP-Befehl ist (schneller)
!shufpd xmm0,dqword[Y],10b   ;Bit0 = 0 = unteres Quad-Word von Op.1 in unteres Quad-Word von Op.1 
!movdqu dqword[R],xmm0       ; Bit1 = 1 = oberes Quad-Word von Op.2 in oberes Quad-Word von Op.1

MessageRequester("SHUFPD", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                          oberes Quad-Word           unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ       1122334455667788h          ;unteres Quad-Word von X (in Operand1)
!times 1 DQ 9900AABBCCDDEEFFh          ;oberes Quad-Word von X (in Operand1)
!Y DQ       1111333355557777h          ;unteres Quad-Word von Y (Operand2)
!times 1 DQ 9999BBBBDDDDFFFFh          ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 14
; Folding = -
; EnableAsm
; DisableDebugger