;- Beispiel fr UNPCKHPD
;- Unpack and Interleave High Packed Double-Precision Floating-Point Values
;- SSE2 - kopiert das obere Quad-Word von Operand1 in das untere Quad-Word von Operand1 und das obere
;-  Quad-Word von Operand2 in das obere Quad-Word von Operand1
;- Dateiname 4702.pb
;- "Helle" Klaus Helbing, 07.01.2007, PB v4.02
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein,
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!movupd xmm0,dqword[X]       ;MOVUPD weil nachfolgender Befehl ein DP-FP-Befehl ist (schneller)
!unpckhpd xmm0,dqword[Y]
!movdqu dqword[R],xmm0

MessageRequester("UNPCKHPD", HexQ(PeekQ(?R + 8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                            oberes Quad-Word           unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ       1122334455667788h          ;unteres Quad-Word von X (in Operand1)
!times 1 DQ 9900AABBCCDDEEFFh          ;oberes Quad-Word von X (in Operand1)
!Y DQ       1111333355557777h          ;unteres Quad-Word von Y (Operand2)
!times 1 DQ 9999BBBBDDDDFFFFh          ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 21
; Folding = -
; EnableAsm
; DisableDebugger