;- Beispiel fr MOVSLDUP
;- Move Packed Single-Precision Floating-Point Low and Duplicate 
;- SSE3 - kopiert zwei Fliesskommazahlen einfacher Genauigkeit von Operand2 in die vier Double-Words von
;-  Operand1 (Duplizierung). Es wird Double-Word 1 in Double-Word 1 und 2 sowie Double-Word 3 in Double-Word 3
;-  und 4 kopiert
;- Dateiname 5002.pb
;- "Helle" Klaus Helbing, 12.02.2007, PB v4.02
;- Operand1 muss ein 128-Bit-Register sein, Operand2 kann ein 128-Bit-Register oder eine 128-Bit-Variable sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

Global A.f = 1234.5
Global B.f = 678.9
Global C.f = 5432.1
Global D.f = 987.6

;- die 4 FPs (A bis D) werden in ein XMM-Register kopiert
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;in XMM2 stehen jetzt alle 4 Floats, in Double4 = A usw.
                             
!movsldup xmm0,xmm2

!movupd dqword[R],xmm0       ;zur Ausgabe nach R kopieren
 
MessageRequester("MOVSLDUP", StrF(PeekF(?R + 12)) + "   " + StrF(PeekF(?R + 8)) + "   " + StrF(PeekF(?R + 4)) + "   " + StrF(PeekF(?R)))
;                            4.Double-Word                  3.Double-Word                 2.Double-Word                 1.Double-Word
End

!section '.data' Data readable writeable
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 31
; Folding = -
; EnableAsm
; DisableDebugger