;- Beispiel fr ADDSUBPD
;- Packed Double-Floating-Point Add/Subtract  
;- SSE3 - addiert die oberen Doubles und subtrahiert die unteren (Operand1 minus Operand2)
;- Dateiname 5200.pb
;- "Helle" Klaus Helbing, 17.02.2007, PB v4.02
;- Operand1 muss ein 128-Bit-Register sein, Operand2 kann ein 128-Bit-Register oder eine 128-Bit-Variable sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!movupd xmm0,dqword[X]       ;MOVUPD weil nachfolgender Befehl ein DP-FP-Befehl ist (schneller)
!addsubpd xmm0,dqword[Y]
!movupd dqword[R],xmm0

MessageRequester("ADDSUBPD  Summe obere Quad-Words", StrD(PeekD(?R + 8)))
MessageRequester("ADDSUBPD  Differenz untere Quad-Words", StrD(PeekD(?R)))

End

!section '.data' Data readable writeable
!X DQ       8888888888.888             ;unteres Quad-Word von X (in Operand1)
!times 1 DQ 3333333333.333             ;oberes Quad-Word von X (in Operand1)
!Y DQ       1111111111.111             ;unteres Quad-Word von Y (Operand2)
!times 1 DQ 2222222222.222             ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 20
; Folding = -
; EnableAsm
; DisableDebugger