;- Beispiel fr ADDSUBPS
;- Packed Single-Floating-Point Add/Subtract  
;- SSE3 - addiert die Singles 2 und 4 und subtrahiert 1 und 3 (Operand1 minus Operand2)
;- Dateiname 5201.pb
;- "Helle" Klaus Helbing, 17.02.2007, PB v4.02
;- Operand1 muss ein 128-Bit-Register sein, Operand2 kann ein 128-Bit-Register oder eine 128-Bit-Variable sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

Global A.f = 1234.5
Global B.f = 678.9
Global C.f = 5432.1
Global D.f = 987.6
Global E.f = 333.3

;- die 4 FPs (A bis D) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;die beiden unteren Double-Words von XMM1 werden in die beiden oberen
                             ; Double-Words von XMM2 kopiert
!movss xmm0,[v_E]
!shufps xmm0,xmm0,0          ;alle 4 Double-Words erhalten damit den Wert von E  

!addsubps xmm2,xmm0          ;addiert zu 2 und 4 jetzt 333.3 und subtrahiert 333.3 von 1 und 3

!movups dqword[R],xmm2

MessageRequester("ADDSUBPS   Summe von A und E (Double-Word 4)", StrF(PeekF(?R + 12)))
MessageRequester("ADDSUBPS   Differenz von B und E (Double-Word 3)", StrF(PeekF(?R + 8)))
MessageRequester("ADDSUBPS   Summe von C und E (Double-Word 2)", StrF(PeekF(?R + 4)))
MessageRequester("ADDSUBPS   Differenz von D und E (Double-Word 1)", StrF(PeekF(?R)))

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 41
; FirstLine = 1
; Folding = -
; EnableAsm
; DisableDebugger