;- Beispiel fr HADDPD
;- Packed Double-Floating-Point Horizontal Add  
;- SSE3 - addiert die beiden Doubles von Operand1 in das untere Double-Word von Operand1 und die beiden
;-  Doubles von Operand2 in das obere Double-Word von Operand1
;- Dateiname 5202.pb
;- "Helle" Klaus Helbing, 17.02.2007, PB v4.02
;- Operand1 muss ein 128-Bit-Register sein, Operand2 kann ein 128-Bit-Register oder eine 128-Bit-Variable sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

!movupd xmm0,dqword[X]       ;MOVUPD weil nachfolgender Befehl ein DP-FP-Befehl ist (schneller)
!haddpd xmm0,dqword[Y]
!movupd dqword[R],xmm0

MessageRequester("HADDPD  Summe Quad-Words Operand1", StrD(PeekD(?R)))
MessageRequester("HADDPD  Summe Quad-Words Operand2", StrD(PeekD(?R + 8)))

End

!section '.data' Data readable writeable
!X DQ       5555555555.555             ;unteres Quad-Word von X (in Operand1)
!times 1 DQ 4444444444.444             ;oberes Quad-Word von X (in Operand1)
!Y DQ       1111111111.111             ;unteres Quad-Word von Y (Operand2)
!times 1 DQ 2222222222.222             ;oberes Quad-Word von Y (Operand2)
R:
!R DQ ?
!times 1 DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 14
; Folding = -
; EnableAsm
; DisableDebugger