;- Beispiel fr HADDPS
;- Packed Single-Floating-Point Horizontal Add  
;- SSE3 - addiert jeweils 2 Singles von Operand1 in die beiden unteren Double-Words von Operand1 und jeweils
;-  2 Singles von Operand2 in die beiden oberen Double-Words von Operand1. 
;-  Es gilt: Double1 von Operand1 = Double1 plus Double2 von Operand1
;-           Double2 von Operand1 = Double3 plus Double4 von Operand1
;-           Double3 von Operand1 = Double1 plus Double2 von Operand2
;-           Double4 von Operand1 = Double3 plus Double4 von Operand2
;- Dateiname 5203.pb
;- "Helle" Klaus Helbing, 17.02.2007, PB v4.02
;- Operand1 muss ein 128-Bit-Register sein, Operand2 kann ein 128-Bit-Register oder eine 128-Bit-Variable sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

Global A.f = 1234.5
Global B.f =  678.9
Global C.f = 5432.1
Global D.f =  987.6
Global E.f =  333.3

;- die 4 FPs (A bis D) werden in ein XMM-Register geschrieben
!movss xmm0,[v_A]
!movss xmm1,[v_B]
!unpcklps xmm1,xmm0          ;in den beiden unteren Double-Words von XMM1 stehen jetzt A und B

!movss xmm0,[v_C]
!movss xmm2,[v_D]
!unpcklps xmm2,xmm0          ;in den beiden unteren Double-Words von XMM2 stehen jetzt C und D

!movlhps xmm2,xmm1           ;die beiden unteren Double-Words von XMM1 werden in die beiden oberen
                             ; Double-Words von XMM2 kopiert
!movss xmm0,[v_E]
!shufps xmm0,xmm0,0          ;alle 4 Double-Words erhalten damit den Wert von E  

!haddps xmm2,xmm0

!movups dqword[R],xmm2

MessageRequester("HADDPS   Summe von E und E (Double-Word 4)", StrF(PeekF(?R + 12)))
MessageRequester("HADDPS   Summe von E und E (Double-Word 3)", StrF(PeekF(?R + 8)))
MessageRequester("HADDPS   Summe von A und B (Double-Word 2)", StrF(PeekF(?R + 4)))
MessageRequester("HADDPS   Summe von C und D (Double-Word 1)", StrF(PeekF(?R)))

End

!section '.data' Data readable writeable
R:
!R DQ ?                                ;1 Quad-Word reservieren
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 33
; FirstLine = 6
; Folding = -
; EnableAsm
; DisableDebugger