;- Beispiel fr PABSW
;- Packed Absolute Value Words
;- SSSE3 - ermittelt den Absolut-Wert jedes vorzeichenbehafteten Words von Operand2 und schreibt
;-  ihn vorzeichenlos in das korrespondierende Word von Operand1
;- Dateiname 6001.pb
;- "Helle" Klaus Helbing, 21.02.2007, PB v4.02
;- Die Register knnen jeweils MMX- oder XMM-Register sein (kein mischen!) 
;- Operand2 kann ein Register oder eine Variable (64-Bit bei MMX, 128-Bit bei XMM) sein, Operand1
;-  muss ein Register sein 
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- mit MMX-Register
!pabsw mm0,[X]
!movq [R],mm0
!emms

StrIn$="aus   "
StrOut$="wird  "
For n=6 To 0 Step -2
  StrIn$ + " " + Hex(PeekW(?X + n) & 65535)      ;AND 0ffffh  
  StrOut$ + " " + Hex(PeekW(?R + n))
Next 

MessageRequester("PABSW mit MMX-Register", StrIn$ + #LFCR$ + StrOut$)     ;Hex nur wegen deutlicherer Darstellung

;- mit XMM-Register
!pabsw xmm0,dqword[X]
!movdqu dqword[R],xmm0

StrIn$="aus   "
StrOut$="wird  "
For n=14 To 0 Step -2
  StrIn$ + " " + Hex(PeekW(?X + n) & 65535) 
  StrOut$ + " " + Hex(PeekW(?R + n))
Next 

MessageRequester("PABSW mit XMM-Register", StrIn$ + #LFCR$ + StrOut$)

End

;------------------------------------------------------------------------------
!section '.data' Data readable writeable
X:
!X       DQ  8191a2b233334444h
!times 1 DQ 0c1d1e2e566778899h
R:
!R       DQ ?
!times 1 DQ ? 
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableAsm
; DisableDebugger