;- Beispiel fr PABSD
;- Packed Absolute Value Double-Words
;- SSSE3 - ermittelt den Absolut-Wert jedes vorzeichenbehafteten Double-Words von Operand2 und
;-  schreibt ihn vorzeichenlos in das korrespondierende Double-Word von Operand1
;- Dateiname 6002.pb
;- "Helle" Klaus Helbing, 20.02.2007, PB v4.02
;- Die Register knnen jeweils MMX- oder XMM-Register sein (kein mischen!) 
;- Operand2 kann ein Register oder eine Variable (64-Bit bei MMX, 128-Bit bei XMM) sein, Operand1
;-  muss ein Register sein 
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- mit MMX-Register
!pabsd mm0,[X]
!movq [R],mm0
!emms

StrIn$="aus   "
StrOut$="wird  "
For n=4 To 0 Step -4
  StrIn$ + " " + Hex(PeekL(?X + n) & 4294967295) ;AND 0ffffffffh 
  StrOut$ + " " + Hex(PeekL(?R + n))
Next 

MessageRequester("PABSD mit MMX-Register", StrIn$ + #LFCR$ + StrOut$)     ;Hex nur wegen deutlicherer Darstellung

;- mit XMM-Register
!pabsd xmm0,dqword[X]
!movdqu dqword[R],xmm0

StrIn$="aus   "
StrOut$="wird  "
For n=12 To 0 Step -4
  StrIn$ + " " + Hex(PeekL(?X + n) & 4294967295)  
  StrOut$ + " " + Hex(PeekL(?R + n))
Next 

MessageRequester("PABSD mit XMM-Register", StrIn$ + #LFCR$ + StrOut$)

End

;------------------------------------------------------------------------------
!section '.data' Data readable writeable
X:
!X       DQ  8191a2b233334444h
!times 1 DQ 0c1d1e2e566778899h
R:
!R       DQ ?
!times 1 DQ ? 
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableAsm
; DisableDebugger