;- Beispiel fr PHADDSW
;- Packed Horizontal Add Words and Saturate
;- SSSE3 - die Summen aller paarweisen vorzeichenbehafteten Integer-Words von Operand1
;-  als auch von Operand2 werden vorzeichenbehaftet in Operand1 gespeichert. Hierbei wird
;-  saturiert
;- Dateiname 6004.pb
;- "Helle" Klaus Helbing, 08.03.2007, PB v4.02
;- Die Register knnen jeweils MMX- oder XMM-Register sein (kein mischen!) 
;- Operand2 kann ein Register oder eine Variable (64-Bit bei MMX, 128-Bit bei XMM) sein, Operand1
;-  muss ein Register sein 
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- mit MMX-Register
!movq mm0,[X]
!phaddsw mm0,[Y]
!movq [R],mm0
!emms

StrOut$ = "Summe der zwei unteren Words von X : " + Hex(PeekW(?R)) + #LFCR$
StrOut$ + "Summe der zwei oberen Words von X : " + Hex(PeekW(?R + 2)) + #LFCR$
StrOut$ + "Summe der zwei unteren Words von Y : " + Hex(PeekW(?R + 4)) + #LFCR$
StrOut$ + "Summe der zwei oberen Words von Y : " + Hex(PeekW(?R + 6))

MessageRequester("PHADDSW mit MMX-Register", StrOut$)       ;Hex nur wegen deutlicherer Darstellung

;- mit XMM-Register
!movdqu xmm0,dqword[W]
!phaddsw xmm0,dqword[Y]
!movdqu dqword[R],xmm0

StrOut$ = "Summe der zwei unteren Words von W : " + Hex(PeekW(?R)) + #LFCR$
StrOut$ + "Summe der zwei oberen Words von W : " + Hex(PeekW(?R + 2)) + #LFCR$
StrOut$ + "Summe der zwei unteren Words von X : " + Hex(PeekW(?R + 4)) + #LFCR$
StrOut$ + "Summe der zwei oberen Words von X : " + Hex(PeekW(?R + 6)) + #LFCR$
StrOut$ + "Summe der zwei oberen Words von Y : " + Hex(PeekW(?R + 8)) + #LFCR$
StrOut$ + "Summe der zwei unteren Words vonY : " + Hex(PeekW(?R + 10)) + #LFCR$
StrOut$ + "Summe der zwei unteren Words von Z : " + Hex(PeekW(?R + 12)) + #LFCR$
StrOut$ + "Summe der zwei oberen Words von Z : " + Hex(PeekW(?R + 14)) + #LFCR$
StrOut$ + "        Hier siehe die Saturierung !"

MessageRequester("PHADDSW mit XMM-Register", StrOut$)

End

;------------------------------------------------------------------------------
!section '.data' Data readable writeable
!W        DQ  707070707070707h
!X        DQ  101020203030404h
!Y        DQ  505060607070808h
!Z        DQ 7000700009090909h
R:
!R        DQ ?
!times 1  DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableAsm
; DisableDebugger