;- Beispiel fr PHSUBD
;- Packed Horizontal Subtract Double-Words
;- SSSE3 - die Differenzen aller paarweisen vorzeichenbehafteten Integer-Double-Words von Operand1
;-  als auch von Operand2 werden vorzeichenbehaftet in Operand1 gespeichert. Der bitmssig hhere
;-  Teil wird vom tieferen subtrahiert 
;- Dateiname 6006.pb
;- "Helle" Klaus Helbing, 09.03.2007, PB v4.02
;- Die Register knnen jeweils MMX- oder XMM-Register sein (kein mischen!) 
;- Operand2 kann ein Register oder eine Variable (64-Bit bei MMX, 128-Bit bei XMM) sein, Operand1
;-  muss ein Register sein 
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- mit MMX-Register
!movq mm0,[X]
!phsubd mm0,[Y]
!movq [R],mm0
!emms

StrOut$ = "Differenz der beiden Double-Words von X : " + Hex(PeekL(?R)) + #LFCR$
StrOut$ + "Differenz der beiden Double-Words von Y : " + Hex(PeekL(?R + 4))  

MessageRequester("PHSUBD mit MMX-Register", StrOut$)       ;Hex nur wegen deutlicherer Darstellung

;- mit XMM-Register
!movdqu xmm0,dqword[W]
!phsubd xmm0,dqword[Y]
!movdqu dqword[R],xmm0

StrOut$ = "Differenz der beiden Double-Words von W : " + Hex(PeekL(?R)) + #LFCR$
StrOut$ + "Differenz der beiden Double-Words von X : " + Hex(PeekL(?R + 4)) + #LFCR$  
StrOut$ + "Differenz der beiden Double-Words von Y : " + Hex(PeekL(?R + 8)) + #LFCR$
StrOut$ + "Differenz der beiden Double-Words von Z : " + Hex(PeekL(?R + 12))  

MessageRequester("PHSUBD mit XMM-Register", StrOut$)

End

;------------------------------------------------------------------------------
!section '.data' Data readable writeable
!W        DQ 707070707070707h
!X        DQ 101010103030404h
!Y        DQ 808080805050606h
!Z        DQ 909090906060606h
R:
!R        DQ ?
!times 1  DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableAsm
; DisableDebugger