;- Beispiel fr PHSUBSW
;- Packed Horizontal Subtract Words and Saturate
;- SSSE3 - die Differenzen aller paarweisen vorzeichenbehafteten Integer-Words von Operand1
;-  als auch von Operand2 werden vorzeichenbehaftet in Operand1 gespeichert. Der bitmssig hhere
;-  Teil wird vom tieferen subtrahiert. Hierbei wird saturiert
;- Dateiname 6007.pb
;- "Helle" Klaus Helbing, 09.03.2007, PB v4.02
;- Die Register knnen jeweils MMX- oder XMM-Register sein (kein mischen!) 
;- Operand2 kann ein Register oder eine Variable (64-Bit bei MMX, 128-Bit bei XMM) sein, Operand1
;-  muss ein Register sein 
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein!

;- mit MMX-Register
!movq mm0,[X]
!phsubsw mm0,[Y]
!movq [R],mm0
!emms

StrOut$ = "Differenz der zwei unteren Words von X : " + Hex(PeekW(?R)) + #LFCR$
StrOut$ + "Differenz der zwei oberen Words von X : " + Hex(PeekW(?R + 2)) + #LFCR$
StrOut$ + "Differenz der zwei unteren Words von Y : " + Hex(PeekW(?R + 4)) + #LFCR$
StrOut$ + "Differenz der zwei oberen Words von Y : " + Mid(Hex(PeekW(?R + 6)), 5, 4)

MessageRequester("PHSUBSW mit MMX-Register", StrOut$)       ;Hex nur wegen deutlicherer Darstellung

;- mit XMM-Register
!movdqu xmm0,dqword[W]
!phsubsw xmm0,dqword[Y]
!movdqu dqword[R],xmm0

StrOut$ = "Differenz der zwei unteren Words von W : " + Hex(PeekW(?R)) + #LFCR$
StrOut$ + "Differenz der zwei oberen Words von W : " + Hex(PeekW(?R + 2)) + #LFCR$
StrOut$ + "Differenz der zwei unteren Words von X : " + Hex(PeekW(?R + 4)) + #LFCR$
StrOut$ + "Differenz der zwei oberen Words von X : " + Hex(PeekW(?R + 6)) + #LFCR$
StrOut$ + "Differenz der zwei oberen Words von Y : " + Hex(PeekW(?R + 8)) + #LFCR$
StrOut$ + "Differenz der zwei unteren Words vonY : " + Mid(Hex(PeekW(?R + 10)), 5, 4) + #LFCR$
StrOut$ + "Differenz der zwei unteren Words von Z : " + Mid(Hex(PeekW(?R + 12)), 5, 4)  + #LFCR$
StrOut$ + "Differenz der zwei oberen Words von Z : " + Mid(Hex(PeekW(?R + 14)), 5, 4) + #LFCR$
StrOut$ + "        Hier siehe die Saturierung !"

MessageRequester("PHSUBSW mit XMM-Register", StrOut$)

End

;------------------------------------------------------------------------------
!section '.data' Data readable writeable
!W        DQ  707070707070707h
!X        DQ  101020503030708h
!Y        DQ  808060607070808h
!Z        DQ 6000900008080707h
R:
!R        DQ ?
!times 1  DQ ?
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 49
; FirstLine = 18
; Folding = -
; EnableAsm
; DisableDebugger