;- Beispiel fr BLENDPD
;- Blend Packed Double Precision Floating-Point Values
;- SSE4.1 - kopiert die durch die Bits 0 (unteres Quad-Word) und 1 (oberes Quad-Word) von
;-  Operand3 reprsentierten Quad-Words von Operand2 in Operand1; gesetztes Bit = kopieren,
;-  ungesetztes Bit = dieses Quad-Word von Operand1 bleibt unverndert 
;- Dateiname 7000.pb
;- "Helle" Klaus Helbing, 22.02.2008, PB v4.10
;- Operand2 kann ein XMM-Register oder eine 128-Bit-Variable sein, Operand1 muss ein XMM-Register sein
;- Operand3 muss eine 8-Bit-Zahl sein
;- WICHTIG: Ist Operand2 eine 128-Bit-Variable, muss diese 16-Byte-Aligned sein! 

!movupd xmm0,dqword[X]       ;ldt X (128 Bit)
!movupd xmm1,dqword[Y]
;!blendpd xmm0,dqword[Y],1   ;?   evtl. nchste Version von FAsm 
!blendpd xmm0,xmm1,1         ;1 = nur unteres Quad-Word kopieren (nur Bit0 gesetzt)
!movupd dqword[R],xmm0
 
MessageRequester("BLENDPD", HexQ(PeekQ(?R+8)) + RSet(HexQ(PeekQ(?R)),16,"0"))
;                           oberes Quad-Word         unteres Quad-Word
End

!section '.data' Data readable writeable
!X DQ       101020203030404h           ;unteres Quad-Word von X (Operand1)
!times 1 DQ 505060607070808h           ;oberes Quad-Word
!Y DQ       101010101010101h           ;unteres Quad-Word von Y (Operand2)
!times 1 DQ 202020202020202h           ;oberes Quad-Word
R:
!R DQ ?                                ;1 Quad-Word reservieren (direkt ein Double-Quad-Word geht nicht)
!times 1 DQ ?                          ;noch ein weiteres Quad-Word reservieren
; IDE Options = PureBasic 4.10 (Windows - x86)
; CursorPosition = 15
; Folding = -
; EnableAsm
; DisableDebugger